From 4ddae80e7d9ef26959067c671ec935e0e64ac498 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Jan 03 2021 00:48:50 +0000
Subject: [PATCH 1995/2232] Allow through bad_alloc from Error(const Error &) and operator=


---

diff --git a/src/cxx.cc b/src/cxx.cc
index 56c3696..9983fba 100644
--- a/src/cxx.cc
+++ b/src/cxx.cc
@@ -353,15 +353,21 @@ static_assert(!std::is_same<Vec<std::uint8_t>::const_iterator,
                             Vec<std::uint8_t>::iterator>::value,
               "Vec<T>::const_iterator != Vec<T>::iterator");
 
+static const char *errorCopy(const char *ptr, std::size_t len) {
+  char *copy = new char[len];
+  std::memcpy(copy, ptr, len);
+  return copy;
+}
+
 extern "C" {
 const char *cxxbridge1$error(const char *ptr, std::size_t len) noexcept {
-  return ptr ? static_cast<char *>(std::memcpy(new char[len], ptr, len))
-             : nullptr;
+  return errorCopy(ptr, len);
 }
 } // extern "C"
 
 Error::Error(const Error &other)
-    : std::exception(other), msg(cxxbridge1$error(other.msg, other.len)),
+    : std::exception(other),
+      msg(other.msg ? errorCopy(other.msg, other.len) : nullptr),
       len(other.len) {}
 
 Error::Error(Error &&other) noexcept
@@ -377,8 +383,10 @@ Error &Error::operator=(const Error &other) {
     std::exception::operator=(other);
     delete[] this->msg;
     this->msg = nullptr;
-    this->msg = cxxbridge1$error(other.msg, other.len);
-    this->len = other.len;
+    if (other.msg) {
+      this->msg = errorCopy(other.msg, other.len);
+      this->len = other.len;
+    }
   }
   return *this;
 }

